import os
import shutil
import sys
import traceback

from service.import_data_service import get_exec_data, run_fail
from trans.ImportParam import ImportParam
from utils.conf.read_conf import read_conf, yaml_conf
from utils.log.import_data_log import log_print


def run_data(env_conf):
    run_count = read_conf(env_conf, 'run_count', 1)
    run_data = get_exec_data(run_count)
    if run_data:
        import_param = None
        try:
            import_param = ImportParam(run_data, env_conf)
            import_param.run()

        except Exception as e:
            log_print(traceback.format_exc())
            run_fail(run_data['id'], str(e))
            log_print("开始删除临时文件夹")
            # if import_param and os.path.exists(import_param.tmp_root):
            #     shutil.rmtree(import_param.tmp_root)
            log_print("删除临时文件夹删除成功")


if __name__ == '__main__':
    from utils.common_util import get_project_conf_path_file

    env = 'dev'

    if len(sys.argv) >= 2:
        env = sys.argv[1]

    conf_path = get_project_conf_path_file(env)
    env_conf = yaml_conf(conf_path)
    run_data(env_conf)
